# $Revision: 1.81.2.2 $, $Date: 2008-03-12 11:36:13 $
#
# Conditional build:
%bcond_with	snmp        # build with snmp support
#
%include	/usr/lib/rpm/macros.perl
# FIXME:
# - won't be good to include these contrib examples?
#   Source1:	http://www.ping.de/~fdc/radius/radacct-replay
#   Source3:	ftp://ftp.freeradius.org/pub/radius/contrib/radwho.cgi
Summary:	High-performance and highly configurable RADIUS server
Summary(pl.UTF-8):	Szybki i wysoce konfigurowalny serwer RADIUS
Name:		freeradius
Version:	1.1.7
Release:	2
License:	GPL
Group:		Networking/Daemons
Source0:	ftp://ftp.freeradius.org/pub/radius/%{name}-%{version}.tar.gz
# Source0-md5:	5c126cb2122b8e2ba9784b511fbefd96
Source1:	%{name}.logrotate
Source2:	%{name}.init
Source3:	%{name}.pam
Patch0:		%{name}-makefile.patch
Patch1:		%{name}-linking.patch
Patch2:		%{name}-moduledir.patch
Patch3:		%{name}-rundir.patch
Patch4:		%{name}-config.patch
URL:		http://www.freeradius.org/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	cyrus-sasl-devel
BuildRequires:	gdbm-devel
BuildRequires:	libltdl-devel
BuildRequires:	libtool
BuildRequires:	mysql-devel
%{?with_snmp:BuildRequires:	net-snmp-compat-devel}
BuildRequires:	net-snmp-devel
BuildRequires:	openldap-devel >= 2.3.0
BuildRequires:	openssl-devel >= 0.9.7d
BuildRequires:	pam-devel
BuildRequires:	perl-devel
BuildRequires:	postgresql-backend-devel
BuildRequires:	postgresql-devel
BuildRequires:	python
BuildRequires:	python-devel
BuildRequires:	rpm-perlprov
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	unixODBC-devel
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires(pre):	/usr/sbin/usermod
Requires:	perl(DynaLoader) = %(%{__perl} -MDynaLoader -e 'print DynaLoader->VERSION')
Requires:	rc-scripts
Provides:	group(radius)
Provides:	user(radius)
Obsoletes:	cistron-radius
Conflicts:	logrotate < 3.7-4
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The FreeRADIUS Server Project is an attempt to create a
high-performance and highly configurable GPL'd RADIUS server. It is
generally similar to the Livingston 2.0 RADIUS server, but has a lot
more features, and is much more configurable.

%description -l pl.UTF-8
Projekt FreeRadius ma na celu stworzenie szybkiego i wysoce
konfigurowalnego serwera RADIUS na licencji GPL. Ten jest podobny do
Livingston 2.0 RADIUS server ale ma o wiele więcej funkcji i posiada
większe możliwości konfigurowania.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

sed -e '/m4_include..libtool/d' < aclocal.m4 > acinclude.m4

%build
maindir="$(pwd)"
for d in rlm_attr_rewrite rlm_checkval rlm_counter rlm_dbm \
	rlm_eap/types/rlm_eap_{md5,mschapv2,peap,sim,tls,ttls} \
	rlm_eap rlm_example rlm_ippool rlm_krb5 rlm_ldap rlm_otp \
	rlm_pam rlm_perl rlm_python rlm_radutmp rlm_smb \
	rlm_sql/drivers/rlm_sql_{db2,iodbc,mysql,oracle,postgresql,unixodbc} \
	rlm_sql rlm_sqlcounter rlm_sql_log rlm_unix ; do

	cd src/modules/${d}
	if [ -f configure.in ]; then
		%{__aclocal} -I ${maindir}
		%{__autoconf}
	fi
	if [ -f config.h.in ]; then
		%{__autoheader}
	fi
	cd ${maindir}
done
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%configure \
	SNMPGET="/usr/bin/snmpget" \
	SNMPWALK="/usr/bin/snmpwalk" \
	--enable-strict-dependencies \
	--with-logdir=%{_var}/log/freeradius \
	--with-experimental-modules \
	--with-threads \
	--with-thread-pool \
	--with-gnu-ld \
	--with-ltdl-include=%{_includedir}/none \
	--with-ltdl-lib=%{_libdir} \
	--disable-ltdl-install \
	--without-rlm_krb5 \
	--without-rlm_dbm \
	--with%{!?with_snmp:out}-snmp
%{__make} -j1 \
	LIBTOOL="`pwd`/libtool --tag=CC"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir}/raddb,%{_libdir}/%{name}} \
	$RPM_BUILD_ROOT/etc/{logrotate.d,pam.d,rc.d/init.d} \
	$RPM_BUILD_ROOT%{_var}/log/{,archive}/freeradius/radacct

%{__make} -j1 install \
	LIBTOOL="`pwd`/libtool --tag=CC" \
	R=$RPM_BUILD_ROOT

rm -f $RPM_BUILD_ROOT{%{_mandir}/man8/builddbm.8,%{_sbindir}/rc.radiusd}
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/raddb/{clients,*.pl}

install %{SOURCE1}	$RPM_BUILD_ROOT/etc/logrotate.d/%{name}
install %{SOURCE2}	$RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
install %{SOURCE3}	$RPM_BUILD_ROOT/etc/pam.d/radius

# remove useless static modules and library
# rlm*.la are used (lt_dlopen)
rm -f $RPM_BUILD_ROOT%{_libdir}/{*.a,*.la}
rm -f $RPM_BUILD_ROOT%{_libdir}/%{name}/*.a
rm -rf $RPM_BUILD_ROOT%{_docdir}/freeradius

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 29 -r -f radius
%useradd -u 29 -d %{_localstatedir} -s /bin/false -M -r -c "%{name}" -g radius radius

# TODO: should be in trigger instead.
# upgrade from previous versions of the package, where radius' gid was "nobody"
if [ "`id -g radius`" = "99" ]; then
	usermod -g 29 radius
	chown radius:radius /var/log/%{name}/*.log >/dev/null 2>&1 || :
	chown radius:radius /var/log/%{name}/radacct/* >/dev/null 2>&1 || :
fi

%post
/sbin/chkconfig --add %{name}
%service %{name} restart "%{name} daemon"

%preun
if [ "$1" = "0" ]; then
	%service %{name} stop
	/sbin/chkconfig --del %{name}
fi

%postun
if [ "$1" = "0" ]; then
	%userremove radius
	%groupremove radius
fi

%files
%defattr(644,root,root,755)
%doc doc/*
%attr(755,root,root) %{_bindir}/*
%attr(755,root,root) %{_sbindir}/*
%attr(755,root,root) %{_libdir}/*.so
%dir %{_libdir}/%{name}
%attr(755,root,root) %{_libdir}/%{name}/*.so
%{_libdir}/%{name}/*.la
%{_datadir}/freeradius

%dir %{_sysconfdir}/raddb
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/raddb/*

%attr(771,root,radius) %dir %{_var}/log/%{name}
%attr(771,root,radius) %dir %{_var}/log/%{name}/radacct
%attr(771,root,radius) %dir %{_var}/log/archive/%{name}
%attr(771,root,radius) %dir %{_var}/log/archive/%{name}/radacct
%attr(775,root,radius) %dir /var/run/%{name}

%attr(754,root,root) /etc/rc.d/init.d/%{name}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/pam.d/*
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/*

%{_mandir}/man?/*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: freeradius.spec,v $
Revision 1.81.2.2  2008-03-12 11:36:13  glen
- enable snmp suppport (patch by Ilja Bobkevič <ilja.bobkevic at delfi.lt>)

Revision 1.81.2.1  2008-03-05 11:31:38  glen
- merged 1.1.7 update from HEAD to AC-branch

Revision 1.81  2008-03-05 11:29:45  glen
- rm unpackaged docs, adapter

Revision 1.80  2008-02-23 19:40:52  glen
- release 2

Revision 1.79  2008-01-15 16:46:56  baggins
- rel 1

Revision 1.78  2007-12-31 01:40:23  zbyniu
- up to 1.1.7

Revision 1.77  2007-11-03 02:10:03  baggins
- updated openldap BR/R to 2.4.6

Revision 1.76  2007/09/11 12:30:07  gotar
- oops, it's 3.7-4 not 3.7.4

Revision 1.75  2007/09/11 12:15:57  gotar
- C: logrotate < 3.7.4 due to archiv -> archive transition

Revision 1.74  2007/05/18 00:33:27  zbyniu
- update finished

Revision 1.73  2007/05/16 21:20:49  sparky
- updated linking patch
- make -j1, failt otherwise
- some files disappeared
- builds, but needs fixed openldap; zbyniu, it's your turn

Revision 1.72  2007/05/16 18:26:19  qboosh
- CVE references

Revision 1.71  2007/05/16 18:15:36  sparky
- started update to 1.1.6, work-in-progress
 [fixes CVE-2007-0080 CVE-2007-2028]

Revision 1.70  2007/04/26 20:58:22  qboosh
- CVE reference

Revision 1.69  2007/04/02 17:29:46  baggins
- more s|/var/log/archiv|/var/log/archive|g

Revision 1.68  2007/04/02 16:55:17  baggins
- s|/var/log/archiv|/var/log/archive|g

Revision 1.67  2007/03/31 22:53:41  baggins
- add kerberos 5 support

Revision 1.66  2007/02/13 07:16:44  glen
- tabs in preamble

Revision 1.65  2007/02/12 00:48:50  baggins
- converted to UTF-8

Revision 1.64  2006/04/14 14:57:20  glen
- 1.1.1, NFY, patches need review (too much for me right now)
  [fixes CVE-2006-1354]

Revision 1.63  2006/04/04 20:56:59  glen
- add security todo

Revision 1.62  2006/03/27 12:41:11  glen
- rel 2 (libmysqlclient_15)

Revision 1.61  2006/03/09 17:13:03  baggins
- release 1
- works

Revision 1.60  2006/03/09 17:06:03  baggins
- updated to 1.1.0

Revision 1.59  2006/02/27 23:21:21  glen
- use %service

Revision 1.58  2006/02/07 22:36:39  qboosh
- unified, killed PreReq

Revision 1.57  2006/01/17 15:53:45  baggins
- release 5
- BR openldap 2.3

Revision 1.56  2006/01/05 12:30:45  baggins
- added missing dir

Revision 1.55  2006/01/05 12:21:53  baggins
- rel 4
- added archiv log dir

Revision 1.54  2005/10/27 17:40:16  arekm
- rel 3

Revision 1.53  2005/08/04 11:56:41  jajcus
- freeradius.speciles updated for the latest change in nstall

Revision 1.52  2005/08/04 11:06:07  jajcus
- stupid 'R: libtool' removed
- remove all %{_libdir}/*.la

Revision 1.51  2005/08/04 10:55:40  jajcus
- Security bugfix for SQL injection vulnerability described in:
  http://www.gentoo.org/security/en/glsa/glsa-200505-13.xml
  (-sql_injection.patch)

Revision 1.50  2005/08/04 10:45:21  jajcus
- Release: 2
- fixed modules and libraries installation order so rlm_eap.so is included in
  the package built with current libtool (-eap_install_order.patch)

Revision 1.49  2005/05/17 19:02:57  glen
- TODO security

Revision 1.48  2005/05/12 23:45:10  zbyniu
- up to 1.0.2; BR: python

Revision 1.47  2005/05/02 18:23:51  glen
- adapterized

Revision 1.46  2005/05/01 17:31:30  glen
- use %useradd/%groupadd macros

Revision 1.45  2005/03/12 12:32:37  troll
- mass commit: remove obsolete BR: rpm-pythonprov

Revision 1.44  2005/02/12 19:50:02  arekm
- rel ++

Revision 1.43  2005/02/04 23:37:44  ankry
- pl fix

Revision 1.42  2004/12/26 19:19:16  saq
- release 3 for rebuild with python 2.4

Revision 1.41  2004/11/20 17:32:17  radek
- release 2: require DynaLoader in version available at build time

Revision 1.40  2004/10/27 12:05:27  jajcus
- Release: 1 (no protests -> it is going to Ac)

Revision 1.39  2004/10/15 08:02:29  jajcus
- %files fixes (logdir permisions and rundir)

Revision 1.38  2004/10/14 07:24:28  jajcus
- Version: 1.0.1
- modules moved from %{_libdir} to %{_libdir}/%{name}
- radius group added and used (uid is not enough for good access control, and group 'nobody'
  should not be used for any file).

Revision 1.37  2004/09/29 16:32:34  kolodko
- added macros in /etc/logrotate.d

Revision 1.36  2004/09/28 21:30:01  blues
- SECURITY note for future.

Revision 1.35  2004/07/28 08:03:13  troll
- removed %include /usr/lib/rpm/macros.python

Revision 1.34  2004/05/08 15:29:15  qboosh
- added netsnmp patch to use net-snmp instead of ucd-snmp
- pass SNMPGET,SNMPWALK to not BR net-snmp-utils
- release 2

Revision 1.33  2004/05/03 22:57:19  havner
- rel 1 for ac (baggins)

Revision 1.32  2004/03/19 23:46:25  ankry
- massive change: BR openssl-devel >= 0.9.7d

Revision 1.31  2004/02/05 12:02:40  zagrodzki
- add database schema

Revision 1.30  2004/01/05 20:23:05  ankry
- new head/tail syntax

Revision 1.29  2003/11/28 20:45:54  qboosh
- updated to 0.9.3 (fixes DoS vulnerability in "Tunnel-Password" attr handling)
- added rlm_smb-overflow patch for buffer overflow in rlm_smb module
- added ac patch to fix some ac/lt issues and allow rebuild ac

Revision 1.28  2003/11/02 11:21:13  djrzulf
- temporary disabled gdbm linking,

Revision 1.27  2003/11/02 10:59:08  djrzulf
- started update do 0.9.2,
- NFY,

Revision 1.26  2003/09/30 20:18:23  eothane
- ahh, what the hell: openssl 0.9.7c

Revision 1.25  2003/08/22 15:33:15  ankry
- spaces -> tabs

Revision 1.24  2003/07/29 15:12:20  qboosh
- more specific Requires

Revision 1.23  2003/05/28 12:58:56  malekith
- massive attack: source-md5

Revision 1.22  2003/05/25 05:47:32  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.21  2003/05/17 07:02:39  pascalek
- revert user changes

Revision 1.20  2003/05/10 09:53:45  pascalek
- Req user-radius

Revision 1.19  2003/02/13 14:02:05  juandon
- force to use openssl >= 0.9.7, idea by kloczek

Revision 1.18  2002/12/07 23:49:19  ankry
- fix improper usage of %{_sysconfdir}

Revision 1.17  2002/12/07 14:33:00  ankry
- fix improper usage of %{_sysconfdir}

Revision 1.16  2002/11/25 14:13:02  ankry
- massive attack: no need for 755 for *.la

Revision 1.15  2002/08/09 16:11:29  misiek
- started update

Revision 1.14  2002/04/25 16:19:40  arturs
- fixed a small typo

Revision 1.13  2002/02/23 02:06:15  kloczek
- adapterized.

Revision 1.12  2002/02/22 23:28:55  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.11  2002/01/18 02:12:58  kloczek
- perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.10  2001/12/07 21:12:45  mkochano
- /etc/pam.d/* marked with %config(noreplace).
- Release++ (I'm too lazy to write here new release number for each
  spec. Sorry).

Revision 1.9  2001/11/27 10:19:03  qboosh
- fixed pl description mark, cosmetics

Revision 1.8  2001/11/16 19:09:34  filon
- removed second BuildRoot definition
- %{_prefix}/man changed to %{_mandir}

Revision 1.7  2001/11/14 11:44:19  filon
- changed to %configure2_13, to make it build

Revision 1.6  2001/09/24 12:42:14  qboosh
- s/postin/post

Revision 1.5  2001/07/26 05:42:07  saq
- reverting last change: removing new macros from %p{re,ost}{,un}

Revision 1.3  2001/07/02 01:40:49  agaran
- need more fixes, because dont detect proper location of pgsql headers
  (maybe ac/am broken) and some parts looks ugly, btw we should use rm or
  %{__rm} and so on?
